#include <cstdio>
#include <cstdlib>
#include <cstring>
#include "IioImage.h"

using sparse_filter::IioImage;

// c: pointer to original argc
// v: pointer to original argv
// o: option name after hyphen
// d: default value (if NULL, the option takes no argument)
const char *pick_option(int *c, char **v, const char *o, const char *d) {
    int id = d ? 1 : 0;
    for (int i = 0; i < *c - id; i++) {
        if (v[i][0] == '-' && 0 == strcmp(v[i] + 1, o)) {
            char *r = v[i + id] + 1 - id;
            for (int j = i; j < *c - id; j++)
                v[j] = v[j + id + 1];
            *c -= id + 1;
            return r;
        }
    }
    return d;
}


int main(int argc, char *argv[]) {
	
	if (argc < 3) {
        fprintf(stderr, "too few parameters\n");
        fprintf(stderr, "usage: %s input output\n", argv[0]);
        return 1;
    }
	
    IioImage source(argv[1]);
	
	int t = atoi(pick_option(&argc, argv, "t", "1"));

	if (t!=1) {
		fprintf(stderr,"Non-valid option\n");
		return 1;
	}

    // Sauvegarde de l'image de sortie
    source.Save(argv[2]);
	return 0;
}
